class Pettanr.PlainSpeechBalloon
  
class Pettanr.PlainSpeechBalloon.SpeechBalloon extends Backbone.Model
  # OMG... this model is not petanized item
  # it means that can't change name
  base_name: () ->
    "plain_speech_balloons"
  
  baseName: () ->
    "PlainSpeechBalloon"
  
  item_name: () ->
    @base_name() + '/speech_balloon'
  
  table_name: () ->
    @base_name() + '/speech_balloons'
  
  singular: () ->
    @baseName() + '/SpeechBalloon'
  
  plural: () ->
    @baseName() + '/SpeechBalloons'
  
  engine_name: () ->
    @table_name()
  
  form_name: () ->
    @engine_name() + '/speech_balloons'

class Pettanr.PlainSpeechBalloon.Balloon extends Backbone.Model
  # OMG... this model is not petanized item
  # it means that can't change name
  base_name: () ->
    "plain_speech_balloons"
  
  baseName: () ->
    "PlainSpeechBalloon"
  
  item_name: () ->
    @base_name() + '/balloon'
  
  table_name: () ->
    @base_name() + '/balloons'
  
  singular: () ->
    @baseName() + '/Balloon'
  
  plural: () ->
    @baseName() + '/Balloons'
  
  engine_name: () ->
    @table_name()
  
  form_name: () ->
    @engine_name() + '/balloons'

class Pettanr.PlainSpeechBalloon.Speech extends Backbone.Model
  # OMG... this model is not petanized item
  # it means that can't change name
  base_name: () ->
    "plain_speech_balloons"
  
  baseName: () ->
    "PlainSpeechBalloon"
  
  item_name: () ->
    @base_name() + '/speech'
  
  table_name: () ->
    @base_name() + '/speeches'
  
  singular: () ->
    @baseName() + '/Speech'
  
  plural: () ->
    @baseName() + '/Speeches'
  
  engine_name: () ->
    @table_name()
  
  form_name: () ->
    @engine_name() + '/speeches'

class Pettanr.PlainSpeechBalloon.SpeechBalloonModule
  supply_default: () ->
    super()
    sbt = @speech_balloon_template()
    sbt.fetch({cache: true}).done =>
      @speech_balloon_template_module_name = sbt.get('module_name')
  
  speech_balloon_extend: () ->
    @new_speech_balloon() if not @sbex
    @sbex
  
  speech_balloon_extend_setter: (params) ->
    # load attributes
    @sbex = new Pettanr.PlainSpeechBalloon.SpeechBalloon(params)
    # no supply default params
  
  new_speech_balloon: (params = {}) -> 
    @sbex = new Pettanr.PlainSpeechBalloon.SpeechBalloon(params)
    @sbex.supply_default()
  
class Pettanr.PlainSpeechBalloon.BalloonModule
  supply_default: () ->
    super()
    s = @parsed_settings()['all']['balloon']
    @set({
      x: 0,
      y: 0,
      width: @parsed_settings()['speech_balloon']['default_width'],
      eight: @parsed_settings()['speech_balloon']['default_height'],
      r: 0
    })
  
  balloon_extend: () ->
    @new_balloon() if not @bex
    @bex
  
  balloon_extend_setter: (params) ->
    # load attributes
    @bex = new Pettanr.PlainSpeechBalloon.Balloon(params)
    # no supply default params
  
  new_balloon: (params = {}) -> 
    @bex = new Pettanr.PlainSpeechBalloon.Balloon(params)
    @bex.supply_default()
  
  parsed_settings: () ->
    return @parsed if @parsed
    sbt = @speech_balloon_template()
    sbt.fetch({cache: true}).done =>
      @parsed = sbt.parsed_settings()
  
  select_system_picture: () ->
    s = @parsed_settings()['all']['balloon']
    sid = s['system_picture_id']
    @set('system_picture_id', sid)
    sid
  
class Pettanr.PlainSpeechBalloon.SpeechModule
  supply_default: () ->
    super()
    s = @parsed_settings()['all']['speech']
    @set({
      x: s['x_rate'],
      y: s['y_rate'],
      width: s['width_rate'],
      height: s['height_rate'],
      quotes: '',
      font_size: @parsed_settings()['speech_balloon']['default_font_size'],
      text_align: @parsed_settings()['speech_balloon']['default_text_align'],
      fore_color: @parsed_settings()['speech_balloon']['default_fore_color'],
    })
  
  speech_extend: () ->
    @sex
  
  speech_extend_setter: (params) ->
    # load attributes
    @sex = new Pettanr.PlainSpeechBalloon.Speech(params)
    # no supply default params
  
  new_speech: (params = {}) -> 
    @sex = new Pettanr.PlainSpeechBalloon.Speech(params)
    @sex.supply_default()
  
  parsed_settings: () ->
    return @parsed if @parsed
    sbt = @speech_balloon_template()
    sbt.fetch({cache: true}).done =>
      @parsed = sbt.parsed_settings()
  
  arrayed_quotes: () ->
    q = if Pettanr.is_blank(@get('quotes'))
      Pettanr.to_s(@parsed_settings()['speech_balloon']['quotes'])
    else
      @get('quotes')
    q.split(' ')
  
