class Pettanr.ComicsController extends Pettanr.AppController
  
  index: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  by_author: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  by_story: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  show: () ->
    @set_show(@render_show)
  
  render_show: () -> 
    switch @params['format']
      when 'prof'
        @show_prof()
      when 'html'
        @show_html()
  
  show_html: () -> 
    @trigger('title', @params, @item.get('title'))
    show = new Pettanr.Views.Comic.Show({
      item: @item,
      operators: @operators
    })
    show.render()
    @trigger('ready', show)
    @trigger('done', @params)
  
  play: () ->
    # no limit no pager
    @params['page_size'] = -1
    @set_play(@render_play)
  
  render_play: () ->
    @list.open(() => 
      @trigger('title', @params, @item.get('title'))
      show = new Pettanr.Views.Comic.Play({
        item: @item,
        list: @list,
        operators: @operators
      })
      show.render()
      @trigger('ready', show)
    )
    @trigger('done', @params)
  
  count: () ->
  
  new: () ->
    @trigger('title', @params)
    @form_new()
    @trigger('done', @params)
  
  edit: () ->
    @trigger('title', @params)
    @form_edit()
    @trigger('done', @params)
  
  create: () ->
    @form.item.overwrite({operators: @operators})
    @listenTo(@form, 'success', @post_success)
    @listenTo(@form, 'fail', @post_fail)
    @form.save()
  
  update: () ->
    @form.item.overwrite({operators: @operators})
    @listenTo(@form, 'success', @post_success)
    @listenTo(@form, 'fail', @post_fail)
    @form.save()
  
  destroy: () ->
    @set_show(@render_destroy)
  
  render_destroy: () ->
    @listenTo(@item, 'destroy:success', @destroy_success)
    @listenTo(@item, 'destroy:fail', @destroy_fail)
    @item.destroy()
  
