class Editor.EditorModule.DockModule.ElementBay.Boards extends Backbone.View
  tagName: 'div'
  className: 'boards ui-tabs-vertical ui-helper-clearfix'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @labels = new Editor.EditorModule.DockModule.ElementBay.Labels({
      parent: this
    })
    @listenTo(@labels, 'sorted', @sorted)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@labels.render().$el)
    this
  
  add_element_tab: (tab) ->
    tab.label.render()
    tab.body.render()
    @labels.render()
    this.$el.append(tab.body.$el)
  
  sorted: () ->
    # data-z copy to model
    @trigger('sorted')
  
class Editor.EditorModule.DockModule.ElementBay.Labels extends Backbone.View
  tagName: 'ul'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
  
  render: () ->
    this.$el.html('')
    this.$el.addClass('inner-elements-tabs')
    _.each @zorderd_labels(), (label) =>
      this.$el.append(label.$el)
    _this = this
    this.$el.sortable {
      update: (event, ui) ->
        z = 0
        $('li', $(@)).map ->
          $(@).attr('data-z', z)
          z++
        _this.trigger('sorted')
    }
    this
  
  zorderd_labels: () ->
    res = []
    _.each @bay().tabs, (tab) =>
      res[tab.label.z()] = tab.label
    res
  
  add_label: (label) ->
    #z = label.z
    @labels.push(label) # insert array
    @render()  # sorting
    label.add_label()
  
  bay: () ->
    @parent.parent
  
