class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.EditItemColumnModule.Default extends Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.EditItemColumnModule.Base
  
  initialize: (options) ->
    super(options)
    @edit_icon = new Pettanr.Image.SymbolImg({
      attr: {'src': @edit_img_file_name()}, 
      half: true
    })
    @edit_btn = new Tag.A({
      attr: {href: '/' + @item.edit_url()}, 
      content: @edit_icon.render().el
    })
    @remove_icon = new Pettanr.Image.SymbolImg({
      attr: {'src': @remove_img_file_name()}, 
      half: true
    })
    @remove_btn = new Tag.A({
      attr: {href: '/' + @item.destroy_url()}, 
      content: @remove_icon.render().el
    })
    @listenTo(@edit_btn, 'click', @click_edit)
    @listenTo(@remove_btn, 'click', @click_remove)
  
  render: () ->
    this.$el.html('')
    if @is_own()
      this.$el.append(@edit_btn.render().el)
      this.$el.append(@remove_btn.render().el)
    this
  
  is_own: () ->
    if @item.is_own(@filer().operators)
      true
    else
      false
   
  edit_img_file_name: () ->
    @image_dir() + 'edit.png'
  
  remove_img_file_name: () ->
    @image_dir() + 'remove.png'
  
  click_edit: () ->
    @trigger('http_get', @item.edit_url())
  
  click_remove: () ->
    return if !confirm('remove?')
    proxy = new Pettanr.Proxy({operators: @filer().operators})
    @listenTo(proxy, 'success', @remove_success)
    @listenTo(proxy, 'fail', @remove_fail)
    proxy.http_post(@item.destroy_url())
  
  remove_success: () ->
    @trigger('remove:success')
  
  remove_fail: () ->
    @trigger('remove:fail')
  
