class Locmare.FormModule.FieldModule.LabelModule.Base extends Backbone.View
  tagName: 'label'
  
  initialize: (options) ->
    @field = options.field
    @label_manifest = options.label_manifest
    @rb = @row_break()
  
  form: () ->
    @field.form
  
  manifest: () ->
    @form().manifest
  
  form_name: () ->
    @form().form_name
  
  item: () ->
    @form().item
  
  item_name: () ->
    @label_manifest.item_name()
  
  column_name: () ->
    @label_manifest.column_name()
  
  hidden: () ->
    false
  
  row_break: () ->
    if @label_manifest.row_break
      '<br>'
    else
      null
  
class Locmare.FormModule.FieldModule.LabelModule.Default extends Locmare.FormModule.FieldModule.LabelModule.Base
  
  initialize: (options) ->
    super(options)
  
  label_name: () ->
    'activerecord.attributes.' + @item_name() + '.' +  @column_name()
  
  render: () ->
    this.$el.html('')
    this.$el.append(I18n.t(@label_name()))
    this.$el.append(@rb) if @rb
    this
  
class Locmare.FormModule.FieldModule.LabelModule.None extends Locmare.FormModule.FieldModule.LabelModule.Base
  
  initialize: (options) ->
    super(options)
  
  hidden: () ->
    true
  
