class Locmare.ListGroupModule.Base extends Backbone.Collection
  
  initialize: (options) ->
    @list_group_name = options.list_group_name
    @list_name = options.list_name
    @operators = options.operators
    @params = options.options
    
    @list_group_manifest = LocalManifest.manifest().list_groups[@list_group_name]
    @list_manifest = @list_group_manifest.lists[@list_name]
    
    @controller_name = @list_group_name
    @action_name = @list_name
    @controller_manifest = Manifest.manifest().controllers[@controller_name]
    @action_manifest = @controller_manifest.actions[@action_name]
    @item_name = @action_manifest.item_name
    @model_class = Manifest.item_name_to_model @item_name
    @table_name = @model_class.table_name()
    
  parse: (res) ->
    @page_status = res.page_status
    res.list
  
  items: () ->
    _.map @models, (model) =>
      item = new @model_class(model.attributes)
      Pettanr.cache.store(item)
  
  count: () ->
    new Pettanr.CounterModel({}, {url: '/' + @action_manifest.counter_url(@params)})
  
  open: (cb) ->
    @url = '/' + @action_manifest.url(@params)
    @fetch({cache: true}).done =>
      # @boost(items)
      cb()
  
