class Locmare.ProfilerModule.AssociationModule.HasMany extends Backbone.View
  tagName: 'div'
  
  initialize: (options) ->
    @association = options.association
    @has_many_manifest = options.has_many_manifest
    @filer = null
    controller = Manifest.manifest().controllers[@has_many_manifest.controller_name]
    action = controller.actions[@has_many_manifest.action_name]
    @list = Locmare.ListGroup.list(
      action.path_name(), action.name, 
      @profiler().operators, {id: @item().get('id'), page: 1, page_size: 3}
    )
    @list.open((page_status) =>
      @set_filer()
      @render()
    )
  
  clear: () ->
    this.$el.html('')
    this
  
  render: () ->
    this.$el.html(@filer.el)
    this
  
  set_filer: () ->
    @filer = new Locmare.Filer({
      item_name: @has_many_model().item_name(), 
      items: @list.items(), 
      pager: @pager, 
      operators: @profiler().operators
    })
    @filer.render()
    @listenTo(@filer, 'http_get', @http_get)
    @listenTo(@filer, 'pick', @pick)
  
  item: () ->
    @profiler().item
  
  has_many_model: () ->
    @has_many_manifest.model()
  
  profiler: () ->
    @association.profiler
  
  add_pick: (target_model) ->
    @list.open((page_status) =>
      @set_filer()
      @render()
      @filer.add_pick(target_model)
    )
  
  http_get: (url) ->
    @trigger('http_get', url)
 
  pick: (item) ->
    @trigger('pick', item)
  
