class Locmare.ProfilerModule.Header extends Backbone.View
  tagName: 'div'
  className: 'header'
  
  initialize: (options) ->
    @profiler = options.profiler
    @set_filer()
  
  render: () ->
    this.$el.html(@filer.el)
    this
  
  set_filer: () ->
    @filer = new Locmare.Filer({
      item_name: @profiler.item_name, 
      items: [@profiler.item], 
      pager: @pager, 
      operators: @profiler.operators
    })
    @filer.render()
    @listenTo(@filer, 'http_get', @http_get)
    @listenTo(@filer, 'pick', @pick)
  
  add_pick: (target_model) ->
    @set_filer()
    @render()
    @filer.add_pick(target_model)
  
  http_get: (url) ->
    @trigger('http_get', url)
  
  pick: (item) ->
    @trigger('pick', item)
  
