class Manifest.ItemModule.BasePeta extends ManifestBase.TypeNameArgs
  
  set_default: () ->
    super()
    @args['boost'] ||= {}
    
  init: () ->
    super()
    @parent_item_name = null  # init at leaf, element
    @boost = ManifestBase.load_name_values(this, @args, 'boost', Manifest.ItemModule.Boost)
  
  is_element: () ->
    @parent_item_name != null
  
  find_boost_name: (column_name) -> 
    r = null
    _.each @boost, (boost_manifest, boost_name) ->
      r = boost_name if boost_manifest.settings_column_name == column_name
    r
  
  is_extend_column: (column_name) ->
    r = false
    _.each @boost, (boost_manifest, boost_name) ->
      r = true if boost_manifest.extend_column_name == column_name
    r
  
  supply_defaults: (item) ->
    _.each @boost, (manifest, name) ->
      manifest.supply_default item
  
  overwrites: (item) ->
    _.each @boost, (manifest, name) ->
      manifest.overwrite item
  
  model: () ->
    Manifest.item_name_to_model @name

