class ArtistsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_artist, :only => [:edit, :update, :destroy]
  else
    before_filter :authenticate_resource_reader, :only => [
      :index, :show
    ]
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_artist, :only => [:edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def show_html_format format
    format.html {
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default 
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_create root_path
  end
  
  def update
    set_edit
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_update '/home/configure'
  end
  
  def destroy
    @artist = Artist.edit(params[:id], @operators)
    @artist.destroy
    
    respond_to do |format|
      format.html { redirect_to artists_url }
      format.json { head :ok }
    end
  end
end
