class ScrollsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_filter :authenticate_reader, :only => [
      :top, :index, :show, :play, :by_panel, :by_author
    ]
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_author
    filer_list
  end
  
  def by_panel
    filer_list
  end
  
  def show_html_format format
    format.html {
      @play_list = Locmare::ListGroup.list(
        'scroll_panels', 'by_scroll', @operators, 
        {:id => @item.id, :page_size => -1}  # set no limit options}
      )
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end
  
  def play
    set_play
    play_list
    respond_to do |format|
      format.html {
        if @item.own? @operators
          @fresh_panel_items = assist_items('panels', 'index')
          @new_panel_items = assist_items('home', 'panels')
        end
      }
      list_json_format @list, format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default 
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_create
  end
  
  def update
    set_edit
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_update
  end
  
  def destroy
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    render_destroy '/home/' + @item.path_name
  end
end
