class StoriesController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_filter :authenticate_reader, :only => [
      :index, :show, :play, :by_comic, :by_sheet, :by_author
    ]
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_comic
    filer_list
  end
  
  def by_sheet
    filer_list
  end
  
  def by_author
    filer_list
  end
  
  def show_html_format format
    format.html {
      @play_list = Locmare::ListGroup.list(
        'story_sheets', 'by_story', @operators, 
        {:id => @item.id, :page_size => -1}  # set no limit options
      )
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
    end
  end
  
  def play
    set_play
    @list.options.merge!({'per_page' => 1})    # show one sheet
    @list.reset
    play_list
    respond_to do |format|
      format.html {
        @pager = @list.page_status.pager
        if @item.own? @operators
          @new_sheet_items = assist_items('home', 'sheets')
        end
      }
      list_json_format @list, format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @story = @item
    @item = @my_model_class.new
    @item.supply_default 
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_create
  end
  
  def update
    set_edit
    @story = @item
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_update
  end
  
  def destroy
    @item = Story.edit(params[:id], @operators)
    respond_to do |format|
      if @item.destroy_with_leafs
        flash[:notice] = I18n.t('flash.notice.destroyed', :model => Story.model_name.human)
        format.html { redirect_to '/home/stories' }
        format.json { head :ok }
      else
        flash[:notice] = I18n.t('flash.notice.not_destroyed', :model => Story.model_name.human)
        format.html { redirect_to @item }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end
  
end
