class Scroll < Peta::Binder
  load_manifest
  has_many :scroll_panels
  belongs_to :author
  
  validates :title, :presence => true, :length => {:maximum => 100}
  validates :visible, :presence => true, :numericality => true, :inclusion => {:in => 0..1}
  validates :author_id, :presence => true, :numericality => true, :existence => {:both => false}
  
  def supply_default
    self.visible = 0 if self.visible.blank?
    self.author_id = nil
  end
  
  def overwrite operators
    return false unless operators.author
    self.author_id = operators.author.id
    super()
  end
  
  def visible? operators
    case super
    when nil # super return
      return true
    when false
      return false
    else
      self.visible > 0
    end
  end
  
  def self.public_list_where list
    'scrolls.visible > 0'
  end
  
  def self.show_opt
    {:include => {:scroll_panels => {:panel => {}}, :author => {}}}
  end
  
  def scenario
    panels.map {|panel|
      panel.scenario
    }.join
  end
  
  def plain_scenario
    panels.map {|panel|
      panel.plain_scenario
    }.join
  end
  
end
