ManifestBase.require_modules "local_manifest/filer/", 
  %w|symbol caption summary icon date edit button|

module LocalManifest
  class Filer < ManifestBase::Base
    include FilerModule
    
    attr :item_class,
      :symbol, :caption, :summary, :icon, :date, :edit, :button
    
    def set_default
      super
      @item_class = ::Manifest.item_name_to_model @name
      @json['symbol'] ||= {}
      @json['caption'] ||= {}
      @json['summary'] ||= {}
      @json['icon'] ||= {}
      @json['date'] ||= {}
      @json['edit'] ||= {}
      @json['button'] ||= {}
    end
    
    def init
      super
      @symbol = ManifestBase.load_type_args self, @json, 'symbol', SymbolFactory
      @caption = ManifestBase.load_type_args self, @json, 'caption', CaptionFactory
      @summary = ManifestBase.load_type_args self, @json, 'summary', SummaryFactory
      @icon = ManifestBase.load_type_args self, @json, 'icon', IconFactory
      @date = ManifestBase.load_type_args self, @json, 'date', DateFactory
      @edit = ManifestBase.load_type_args self, @json, 'edit', EditFactory
      @button = ManifestBase.load_type_args self, @json, 'button', ButtonFactory
    end
    
    def item_name
      @name
    end
    
    def filer_name
      @name
    end
    
  end
  
end

