require_dependency "locmare/form/field/helper/base"
require_dependency "locmare/form/field/helper/size"
require_dependency "locmare/form/field/helper/tail_angle"
require_dependency "locmare/form/field/helper/color"
require_dependency "locmare/form/field/helper/popup"
module Locmare
  module FormModule
    module FieldModule
      class HelperFactory
        include HelperModule
        @@types = {
          'size' => Size, 'tail_angle' => TailAngle, 'color' => Color, 
          'popup' => Popup
        }
        def self.factory field, my_manifest
          type = my_manifest.type
          my_class = @@types[type]
          raise "undefined class for local view forms > #{field.form_name} > fields > #{field.field_name} > helper > #{type}\n" unless my_class
          my_class.new(field, my_manifest)
        end
        
      end
      
    end
  end
end
