ManifestBase.require_modules "manifest/item/", 
  %w|base item owner system_resource template content root element binder leaf|

module Manifest
  class ItemFactory < ManifestBase::Factory
    include ItemModule
    
    def self.types
      {
        'item' => ItemPeta, 'owner' => OwnerPeta, 
        'system_resource' => SystemResourcePeta, 'template' => TemplatePeta, 
        'content' => ContentPeta, 
        'root' => RootPeta, 'element' => ElementPeta, 
        'binder' => BinderPeta, 'leaf' => LeafPeta
      }
    end
    
    def self.default_type
      'item'
    end
    
  end
end

